



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Javascript 迭代法实现数组多条件排序</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Javascript 迭代法实现数组多条件排序</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 03:50:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>多条件排序可能有很多种思路，效率也各不相同，我的方法可能只适合自己用，毕竟目的是为了实现功能，所以采用了最笨的方法，不过效果还是很理想的，经过多次测试，6列1000行数据，平均排序时间大约是：28ms。</p>
<p>具体实现代码如下：</p>
<div>
<pre class="prettyprint linenums">    function isArr(data) {<br />
        return ({}).toString.call(data) == '[object Array]';<br />
    }

    function getIndex(arr) {<br />
        var i    = 0,<br />
            len  = arr.length<br />
            keys = [];<br />
        while (i &lt; len) {<br />
            keys.push(i++);<br />
        }<br />
        return keys;<br />
    }

    // 检测数组最大维数，非数组则返回-1，如果有num则表明检测数组是否为指定维数<br />
    function checkArrDim(arr, num) {<br />
        var dimension = -1,<br />
            num       = parseInt(num),<br />
            isCheck   = isNaN(num) ? false : true,<br />
            dm        = [0], i, len, mx;<br />
        if (isArr(arr) &amp;&amp; (len = arr.length) &gt; 0) {<br />
            dimension = 1;  // 任何一个数组，只要有数据，至少是个1维<br />
            for (i = 0; i &lt; len; i++) {<br />
                dm.push(checkArrDim(arr[i]));  // 递归获取每个元素的维数，如果dm数组中全是-1则说明arr是1维数组<br />
            }<br />
            dimension = (mx = Math.max.apply(null, dm)) === -1 ? dimension : dimension + mx;<br />
        }<br />
        // 如果dm数组长度 &lt;= 1则说明arr压根不是数组，或者是空数组<br />
        // 当dm数组长度 &gt; 1，且dimension == 1，说明arr是1维数组<br />
        // 或者dimension &lt;&gt; 1，因为dm默认填充1个0，只要所有元素的和 / dm去掉0后的长度 == num - 1，即说明是n维数组<br />
        return isCheck ? (dm.length &gt; 1 ? (dimension == 1 &amp;&amp; num == 1) || eval(dm.join('+')) / (dm.length - 1) == num - 1 : false) : dimension;<br />
    }

    function msort(arr, field, order) {<br />
        if (!checkArrDim(arr, 2) || !checkArrDim(field, 1) || !checkArrDim(order, 1)) {<br />
            return ;<br />
        }<br />
        var key, tmp, val, sa, sk, pre;<br />
        var i, ilen, j, jlen, k, klen, m, mlen;<br />
        var range = [], rng;<br />
        // 按已排序数组的索引数组排序待定数组<br />
        var sortFromKey = function (data, key) {<br />
            var tmp = [], i, j, len;<br />
            for (i = 0, len = key.length; i &lt; len; i++) {<br />
                tmp.push(data[key[i]]);<br />
            }<br />
            for (j = 0; j &lt; len; j++) {<br />
                data[j] = tmp[j];<br />
            }<br />
        };<br />
        // 多条件排序<br />
        for (i = 0, ilen = field.length; i &lt; ilen; i++) {<br />
            tmp = arr[field[i]];<br />
            if (i === 0) {<br />
                // 第1次排序，直接对当前字段所在数组排序<br />
                key = getIndex(tmp);<br />
                tmp.mergeSort(key, order[i]);<br />
                range.push([0, tmp.length - 1]);<br />
            } else {<br />
                // 如果有第2个及以上的条件，则均以前1个条件为参照，获取前1个已排序数组<br />
                // 内每一组相同元素的区间，对该区间内元素赋值到临时数组并排序，并获取排序<br />
                // 索引，最终拼接在一起这个拼接在一起的新的索引数组即是其它所有数组排序的参照，<br />
                // 经过上述循环执行，即可完成多条件排序<br />
                // &darr;核心工作前的初始工作<br />
                pre = arr[field[i - 1]];  // 前1个已排序数组<br />
                val = pre[0];<br />
                sa  = [tmp[0]];<br />
                sk  = [0];<br />
                key = [];<br />
                rng = [];<br />
                // 本排序核心工作即整理已排序数组的同值区间，此区间是当前待排序数组多个排序区间的唯一参照<br />
                for (k = 0, klen = range.length; k &lt; klen; k++) {<br />
                    for (m = range[k][0] + 1, mlen = range[k][1] + 1; m &lt;= mlen; m++) {  // 注意此处条件表达式，需要额外执行一次排序和初始化<br />
                        if (val === pre[m] &amp;&amp; m !== mlen) {  // 无论区间多小，哪怕只有1个元素，当m = mlen时必须执行排序和下一步的初始准备<br />
                            sa.push(tmp[m]);<br />
                            sk.push(m);<br />
                        } else {<br />
                            rng = rng.concat([[sk[0], sk[sk.length - 1]]]);<br />
                            sa.mergeSort(sk, order[i]);  // 主要是为了获取sk<br />
                            key = key.concat(sk);<br />
                            val = pre[m];<br />
                            sa  = [tmp[m]];<br />
                            sk  = [m];<br />
                        }<br />
                    }<br />
                }<br />
                range = rng;            // 获取整理后的待排序区间<br />
                sortFromKey(tmp, key);  // 对当前数组排序<br />
            }<br />
            // 经过前面的过程，一个条件已经排序完成，并且获得排序后的原索引(数组)<br />
            // 然后对除了当前字段数组外的其它所有数组按已排序索引重新排列<br />
            for (j = 0, jlen = arr.length; j &lt; jlen; j++) {<br />
                if (j == field[i]) {<br />
                    continue;<br />
                }<br />
                sortFromKey(arr[j], key);<br />
            }<br />
        }<br />
    }</pre>
</div>
<p>其中用到数组mergeSort()是自己定义到Array.prototype的方法，链接地址：<a href="http://www.cnblogs.com/go-jzg/p/5812021.html" rel="external nofollow noreferrer">Javascript-归并排序</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k1ox79.html">Java 根据经纬度计算两点之间的距离</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx2zm08.html">nodejs处理get请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r06d79.html">iPhone5停留在语音的界面，提示按三次home键，无法继续下去</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oynzpq.html">windows下CMake使用图文手册 Part 3</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zwoo18.html">Django时间查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k102179.html">Asp&period;Net MVC 模型验证详解-实现客户端、服务端双重验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wx71oq.html">介绍 Android 的 Camera 框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd4em2q.html">使用NuGet安装EntityFramework4&period;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vnpxj8.html">网站开发常用jQuery插件总结&lpar;12&rpar;固定元素插件scrolltofixed</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjzkjk9.html">android开发MD5加密工具类&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gev40e8.html">Linux常用命令&lpar;第二版&rpar; --帮助命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2v7nx9.html">Linux第五节课学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwp1ej9.html">2018-2019-2 20165315 《网络对抗技术》Exp2&plus; 后门进阶</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwwmw09.html">MVC3中 ViewBag、ViewData和TempData的使用和区别（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5ywn4q.html">Spring boot 配置自己的拦截器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdx1kd9.html">自学Python2&period;1-基本数据类型-字符串方法 下</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj7ewz9.html">C&plus;&plus;使用thread类进行多线程编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyp23gq.html">hdu 5120 &lpar;求两圆相交的面积</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko0lw5q.html">第一次软件工程作业（One who wants to wear the crown&comma; Bears the crown&period;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp2l7y9.html">mysql 性能分析及explain用法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j0gd3gq.html">以后坚持用java</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnzx0rq.html">shell常用命令总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjev0y9.html">C&num;调用VC dll输出参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm771e9.html">java项目中eclipse控制台输出log4j的信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjeyxz9.html">&lpar;太强大了&rpar;  -   Linux 性能监控、测试、优化工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjeyyd9.html">poj1515--Street Directions（边的双连通）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvnpvxq.html">Only one database connection at a time is supported</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdmlg78.html">grep -P的一个小问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdelvg09.html">python 语句，条件，循环</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdelv4z9.html">Yii2 富头像上传</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
